#pragma once

class AFX_EXT_CLASS CmdLineSocket : public CCommandLineInfo  
{
public:
	CmdLineSocket();
	virtual ~CmdLineSocket();

	BOOL	Valid;		// true if autoconnect returned true.
	CString	Computer;	// valid if valid is true
	UINT	Port;		// valid if valid is true.

	bool InitializeInstrumentAtStartup() {return m_bInitializeInstrument;}
	// True if command line parameter found and returns specified IP via parameter
	bool GetInstrumentIP(CString& ipOut) { ipOut = m_deviceIP; return m_bOverrideIP; }
	// True if command line parameter found and returns specified SN via parameter
	bool GetInstrumentSN(CString& ipOut) { ipOut = m_deviceSN; return m_bOverrideSN; }
	// True if command line parameter found and returns config data via parameter
	bool GetConfigData(CString& configOut) { configOut = m_configData; return m_bConfigData; }
	// Mantis #3663
	bool RunInSimulationMode() {return m_bRunInSim;}

	bool RunWithoutInitializationRequirements() { return m_bRunWithoutInitRequirements; } // 2017.11.21 - JIRA XIT-613

	virtual void ParseParam( LPCTSTR lpszParam, BOOL bFlag, BOOL bLast );

private:
	// Set whenever the /IP is received
	bool	m_bOverrideIP;
	CString m_deviceIP;

	// Set whenever the /SN is received
	bool	m_bOverrideSN;
	CString m_deviceSN;

	// Additional Command Line Data past from SA
	bool	m_bConfigData;
	CString	m_configData;

	// Set whenever the /Init is received
	bool	m_bInitializeInstrument;

	bool m_bRunInSim;

	bool m_bRunWithoutInitRequirements;  // allow start without initialization requirements (JIRA XIT-613 added for AT40x, beam lock for init, let user automate point, lock, and init after starting interface) 
};
